(***********************************************************************)
(*                                                                     *)
(*                               TAToo                                 *)
(*                                                                     *)
(*                     Kim Nguyen, LRI UMR8623                         *)
(*                   Université Paris-Sud & CNRS                       *)
(*                                                                     *)
(*  Copyright 2010-2012 Université Paris-Sud and Centre National de la *)
(*  Recherche Scientifique. All rights reserved.  This file is         *)
(*  distributed under the terms of the GNU Lesser General Public       *)
(*  License, with the special exception on linking described in file   *)
(*  ../LICENSE.                                                        *)
(*                                                                     *)
(***********************************************************************)

type ('a,'b) node = Nil | Cons of ('a * 'b)

module type S = sig
  type elt
  include Hcons.S
  val nil : t
  val cons : ?sorted:bool -> elt -> t -> t
  val hd : t -> elt
  val tl : t -> t
  val fold : (elt -> 'a -> 'a) -> t -> 'a -> 'a
  val map : (elt -> elt) -> t -> t
  val iter : (elt -> 'a) -> t -> unit
  val rev : t -> t
  val rev_map : (elt -> elt) -> t -> t
  val length : t -> int
  val mem : elt -> t -> bool
end
